<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { computed, inject, ref } from 'vue';
import type { Ref } from 'vue';
import Embedded from '@/components/general/Embedded.vue';
import TextView from '@/components/general/TextView.vue';
import LikeButton from '@/components/general/LikeButton.vue';
import { usePreviewStore } from '@/stores/preview';
import { getFileType } from '@/lib/utils';

const props = defineProps<{
    post: any,
    postIndex: number
}>();

const configuration = inject<any>('configuration');
const store = usePreviewStore();
const { style, commentsAllowed, likesAllowed, postIndex, isExport } = storeToRefs(store);

const handle: Ref<HTMLElement | null> = ref(null);
const element: Ref<HTMLElement | null> = ref(null);

const openCommentCanvas = () => {
    postIndex.value = props.postIndex;
}

const getCommentsLength = computed(() => {
    return props.post.comments.length;
});

const postWidthComputed = computed(()=>{
    return {width: `calc(${style.value.elementWidth}px)`};
});

const elementWidthComputed = computed(()=>{
    return {'--elementWidth': `calc(${style.value.elementWidth}px - 5.5rem)`};
});

const showTopbar = computed(()=>{
    if(props.post.body){
        if(props.post.title.post.toLowerCase().endsWith('.pdf'))
            return true;
        const fileType = getFileType(props.post.body, props.post.title.post)
        return (fileType && fileType !== 'misc' && fileType !== 'h5p') || (props.post.body.image && props.post.body.logo);
    }
    return false;
});

</script>
<template>
    <li class="timeline-element relative" :class="props.postIndex===0?'mr-10':'ml-10'"
        :style="[elementWidthComputed, { '--circleColor': style.lineColor }]"
        v-if="post.authorized">
        <div class="relative box-border bg-white text-gray-500 shadow-md post min-w-36 min-h-20"
            :key="post.id" :id="post.id + 'inner'"
            :style="[{ background: post.color }, { '--bgColor': post.color }, { width: style.elementWidth }, postWidthComputed]"
            :class="[post.shape, props.postIndex===0?'ml-0':'-ml-10']">
            <div class="circle rounded-full size-5 absolute left-[calc(50%-0.75rem)]"></div>
            <div ref="element" class="flex flex-col gap-1">
                <div class="flex flex-row z-10 px-2"
                    :class="[{'bg-white/80':showTopbar},'tb-' + post.shape]">
                    <div class="min-h-7 p-1 hyphens-auto w-full max-h-7 text-ellipsis line-clamp-1" lang="de"
                        :id="'handle_' + post.id">
                        <strong>{{ post.title.headline }}</strong>
                    </div>
                </div>
                <div class="-mt-8" v-if="post.body">
                    <div class="post-content grow flex-auto">
                        <Embedded class="w-full" :key="post.title.post" :body="post.body" :url="post.title.post"
                            :fontSize="style.fontSize" :info="post.info" :topbarClass="'tb-' + post.shape"
                            v-if="post.title.post && post.title.post.length > 0" :isExport="isExport"
                                :exportApi="isExport ? configuration.exportApi : undefined"/>
                    </div>
                </div>
                <div ref="handle" v-else>
                    <div class="post-content grow flex-auto">
                        <TextView :fontSize="style.fontSize" :content="post.title.post" :font-style="style?.font ? style.font : ''"
                            :content-length="-1" />
                    </div>
                </div>
                <div class="flex flex-row justify-between p-1"
                    v-if="(likesAllowed || commentsAllowed) && post.authorized">
                    <div class="w-fit">
                        <LikeButton :likes="post.likes" :likeSymbol="style.likeSymbol"
                            v-if="likesAllowed" />
                    </div>
                    <div class="w-fit">
                        <button class="h-7 p-1 hover:bg-gray-100 select-none flex flex-row rounded-md"
                            @click="openCommentCanvas" v-if="commentsAllowed">
                            <span class="text-xs leading-7 align-bottom"
                                v-if="getCommentsLength <= 99 && getCommentsLength > 0">{{ getCommentsLength }}</span>
                            <span class="text-xs leading-7 align-bottom" v-else-if="getCommentsLength > 99">99+</span>
                            <i class="ri-discuss-line leading-5 text-[20px]"></i>
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </li>
</template>
<style scoped>
.circle {
    background-color: var(--circleColor);
}

.timeline-element:nth-child(even) .circle {
    bottom: -38px;

}

.timeline-element:nth-child(odd) .circle {
    top: -38px;
}

.timeline-element {
    width: var(--elementWidth);
    min-width: var(--elementWidth);
    max-width: var(--elementWidth);
    height: calc(100dvh - 160px);
}

.timeline-element:nth-child(even)>.post {
    top: calc(calc(100vh / 2) - 70px);
    transform: translateY(-100%);
    bottom: 0px;
    max-height: calc(calc(100vh - 240px) / 2);
    height: fit-content;
}

.timeline-element:nth-child(even) .post-content {
    max-height: calc(calc(calc(100vh - 392px) / 2));
    overflow: auto;
}

.timeline-element:nth-child(odd)>.post {
    top: calc(calc(100vh / 2) - 15px);
    max-height: calc(calc(100vh - 100px) / 2);
}

.timeline-element:nth-child(odd) .post-content {
    max-height: calc(calc(calc(100vh - 220px) / 2) - 50px);
    overflow: auto;
}

.timeline-element:nth-child(even) .post-content:after {
    content: "";
    position: absolute;
    width: 15px;
    height: 15px;
    background: var(--bgColor);
    transform: rotate(45deg);
    top: calc(100% - 8px);
    left: calc(50% - 9px);
    filter: drop-shadow(2px 2px 1px rgb(0 0 0 / 8%));
}

.timeline-element:nth-child(odd) .post-content:after {
    content: "";
    position: absolute;
    width: 15px;
    height: 15px;
    background: var(--bgColor);
    transform: rotate(45deg);
    bottom: calc(100% - 8px);
    left: calc(50% - 9px);
    filter: drop-shadow(-2px -2px 1px rgb(0 0 0 / 8%));
}
</style>